// Copyright 2022 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package xflags

import (
	"flag"
	"io"
	"sync"
)

func (s *Settings[C]) initCommands(name string) {
	s.command = buildCommandStruct[C](s, name, "", s.config.errorHandling, []string{})
	s.command.parseStruct(s.definitions)
}

type config struct {
	errorHandling flag.ErrorHandling
}

// Settings[C] is the main struct for the xflags package.
type Settings[C any] struct {
	mu sync.Mutex

	definitions C

	command *cmd[C]

	errors     []error
	flagOutput io.Writer

	args []string

	config config

	mapping     map[string]any
	proxy       Copyable
	wasExecuted bool

	hint string
}

func (s *Settings[C]) GetValues() C {
	return s.definitions
}
